/* this is the sreLite installation program */

call init_it
crlf='0d0a'x

cls
say  " " ; say

call lineout, bold cy_ye
call lineout, "This is the sreLite  (v 1.10) installation program (05 May 2001)."
call lineout, "... an http/1.1 compliant filter for the GoServe OS/2 Internet Server "
call lineout, normal


say " This program will ask for the names of a few directories,"
say " and will copy a number of files to these directories."
say "  "

if yesno(" Are you ready to continue ")=1 then
 nop
else do
 say " See you later?.. "
 exit
end

/* first, check tcp/ip version -- suggest upgrade */
'@inetver | rxqueue '
pull oy
do until queued()=0
      pull oy
end
parse var oy . ':' aver 
parse var aver mainver '.' subver
if mainver='4' then do
  if subver<'02T' then do
      say
      say bold"WARNING: " normal" Your TCP/IP version is "aver
      say "           We "bold"STRONGLY"normal" recommend upgrading to 4.02t (or above)"
     if yesno(" Continue installing sreLite (and upgrade TCP/IP later)?")=1 then do
        say "   Okay, but you may experience sporadic errors."
        say ' '
     end
     else do
        say "As of 1  March 1999, 4.02t info can be found at: "
        say "   ftp://ps.software.ibm.com/ps/products/tcpip/rsu/stack/latestv4.html"
        say "   ftp://ftp.software.ibm.com/ps/products/mpts/fixes/english-us/"
        say "     or you can try:"
        say "   http://duanec.indelible-blue.com/fixes/latestwarp4.html"
        say
        say "See you later.... "
        exit
     end /* do */
  end
end

hh=yesno("Would you like to look at the sreLite manual")
if hh=1 then do
    say " Okay, viewing the sreLite manual ... "
     '@START  "The sreLite Manual" /C /F /WIN E SRELITE.DOC'
    say ' '
end

/* check status of goserve and macrospace routines */
a=dospidlist(l1,l2)
do mm=1 to a
 foo=upper(strip(filespec('n',l2.mm)))
 if foo='GOSERVE.EXE' then do
     say bold " GOSERVE appears to be running " normal
     say " Please shut down GOSERVE  before you (re) install sreLite! "
      exit
  end  /* Do */
end /* do */

call check_macro


adir=filespec("drive",nowdir)
defname=adir||'\GOSERVE'
defname2=adir||'\WWW'

/* -------- Working directory (must exist ) */
if custom_dir=1 then do
  call get_all_dirs
end
else do                 /* use defaults */
  call make_def_dirs
end



/* -- Done with directory creation -- copy files ... */

/* but first, backup? */
 say " "
 call lineout, re_wh "Are you re-installing/upgrading sreLite?  " normal
 call lineout, bold  "If you are ... "
 foo=yesno(normal"     "re_wh"Would you like to archive the various configuration files")
 if foo=1 then do
      say  " Where should sreLite archive these files"
      aa="\BK"||space(translate(date('o'),' ','/\'),0)
      backup_dir=get_dir(workdir||aa)

/* files to backup*/
      in_workdir='NOTFOUND.SHT SRELITE.INI SRELITE0.CMD SRELITE.80 SRELITE1.RXX SRELITE2.RXX '
      in_sdatadir=' USERS.IN'
      in_datadir='INDEX.SHT '
      in_adddir='MAPIMAGE.CMD STATUSL.CMD '
      call dobackup
      yooba=sysfiletree(workdir||'\BK*','goos','OD')
      if goos.0>1  then do
          say bold' Reminder:'normal' you have 'goos.0 ' sreLite archive directories; you might  '
          say     '          want to remove some of the older ones. '
      end /* do */
 end


foo=yesno(" sreLite will now be installed. Are you ready? ")
if foo=0 then do
  say " Try again later ??? "
  exit
end

say " "
say " Copying dynamic link libraries and helper executables .. "
if gotrxlib=1 then do
   say " Note: a copy of REXXLIB seems to be on your system "
end  /* Do */
foo=check_copy('REXXLIB.DLL',workdir)
foo=check_copy('RXGZLIB.DLL',workdir)

say " Copying  sreLite program files files to " workdir
foo=check_copy('*.80' ,workdir,,1)  /* will redo srefiltr.80, but so what */
foo=check_copy('*.RXX',workdir,,1)
foo=check_copy('SRELITEP.RXL',workdir,,1)
foo=check_copy('SRELITE0.CMD',workdir,,1)
foo=check_copy('POSTFILT.CMD',workdir,,1)

foo=check_copy('MTCHFILE.CMD',workdir,,1)
foo=check_copy('NOTFOUND.SHT',workdir,'This is the sample "not found" documents file',1)

say " Copying configuration files "
foo=check_copy('USERS.IN',sdatadir,'Are you sure (this is the username/password file')
foo=check_copy('SRELITE.INI',workdir,'Are you sure (this is the configuration file)')

say " Copying sample files to " helpdir
foo=check_COPY('INDEX.SHT',datadir,'This is a sample home-page, with links to sreLite examples',foo1)
foo=check_COPY('CONFIGU.HTM',datadir,,1)

foo1=check_COPY('TSTHTTPD.SHT',helpdir,,1)
foo=checK_COPY('SAMPMAP.*',helpdir,,foo1)
foo=check_COPY('*.DOC',helpdir,,foo1)
foo=check_copy('SREFILTR.GIF',gifdir,,1)
foo=check_copy('SREFWEB.GIF',gifdir,,1)
foo=check_copy('SREHTTP.GIF',gifdir,,1)

say " Copying sample CGI-Bin scripts to " cgibin_dir
foo=check_copy('XCOUNT.CMD',cgibin_dir,,foo1)
foo=check_copy('JCOUNT.CMD',cgibin_dir,,foo1)
foo=check_copy('TEST-CGI.CMD',cgibin_dir,,foo1)

say " Copying sample addons to " addon_dir
foo=check_copy('MAPIMAGE.CMD',addon_dir,,1)
foo=check_copy('STATUSL.CMD',addon_dir,,1)

foo=check_copy('USERCFGL.CMD',addon_dir,,1)
foo=check_copy('OPTSCFGL.CMD',addon_dir,,1)

meis=directory()



IF INSTALL_ALL=0 then SIGNAL DONE1A

say " "
call lineout, cy_ye ' ------------ Configuration: ' normal
say " "


/* -- add entry to users.in file */
foo=add_user(sdatadir)


say " "


done1: nop

call charout , cy_ye ' (hit any key to continue) ' normal
foo=sysgetkey("noecho")

done1A: nop

a=scrclear()

call lineout, bold cy_ye  " sreLite has been installed... " normal
say " "
say ' Your web site is now ready to be built!  '
say '      (just add documents, images, links, etc...)'
say ' '
say ' Notes:'
say '    * SRELITE.INI (in 'workdir') contains several customization '
say '      (and access control) parmameters.  You can edit it with any text editor.'
say '    * SRELITE.DOC (in 'helpdir') is the sreLite manual'
say '    * INDEX.SHT (in 'datadir') contains links to sample documents, '
say '      and links to a configuration tools.'
exit



/********/
/* copy files to backup directory  */
dobackup:

do mm=1 to words(in_workdir)
     a1=strip(word(in_workdir,mm))

     cto=backup_dir||'\'||a1
     cfrom=workdir||'\'||a1
     if stream(cfrom,'c','query exists')<>"" then do
         call lineout,' Archiving ' cfrom ' ... '
         'COPY 'cfrom ' ' cto ' > nul '
     end  /* Do */

end /* do */
do mm=1 to words(in_sdatadir)
     a1=strip(word(in_sdatadir,mm))
     cto=backup_dir||'\'||a1
     cfrom=sdatadir||'\'||a1
     if stream(cfrom,'c','query exists')<>"" then do
         call lineout,' Archiving ' cfrom ' ... '
         'COPY 'cfrom ' ' cto  ' > nul '
     end
end /* do */

do mm=1 to words(in_datadir)
     a1=strip(word(in_datadir,mm))
     cto=backup_dir||'\'||a1
     cfrom=datadir||'\'||a1
     if stream(cfrom,'c','query exists')<>"" then do
         call lineout,' Copying ' cfrom ' ... '
         'COPY 'cfrom ' ' cto  ' > nul '
     end
end /* do */

do mm=1 to words(in_adddir)
     a1=strip(word(in_adddir,mm))
     cto=backup_dir||'\'||a1
     cfrom=addon_dir||'\'||a1
     if stream(cfrom,'c','query exists')<>"" then do
         call lineout,' Copying ' cfrom ' ... '
         'COPY 'cfrom ' ' cto  ' > nul '
     end
end /* do */



return 0




/*****************/
/* Add an entry to the users.in file */
add_user:procedure expose ipaddr expose reverse bold normal re_wh cy_ye aesc

parse arg sdatadir

say " "
say  bold " Add a SUPERUSER to the UserName database " normal
say " "
say ' To facilitate resetting parameters, and other such actions, we recommend that '
say ' you add a  user, with SUPERUSER privileges, to the sreLite UserName database.'

ok=yesno(normal'    're_wh' Would you like add a SUPERUSER ')
say " "
if ok=0 then do
   say " You can add a user with SUPERUSER privileges by editing USERS.IN "
   return 0
end

bugs: nop
 call charout, bold " Enter a username: " normal
 uname=stringin(,23," ",80)
 say " "

 call charout, bold " Enter a password: " normal
 pwd=stringin(,23," ",80)
 say " "

if uname="" | pwd="" then do
    say " missing username or password: please reenter "
    signal bugs
end  /* Do */


/* read users.in, append uname pwd , write it*/
afile=strip(sdatadir,'t','\')||'\USERS.IN'
foo=sref_fileread(afile,inl,,'E')
oof=uname' 'pwd' SUPERUSER '
ii=inl.0+1
inl.ii=oof
inl.0=ii
foo=filewrite(afile,inl,'R')
if foo=0 then do
   say " Error: could not modify usernames database file: " afile
end
else do
   say " A SUPERUSER has been added, with: "
   say bold uname normal " for the username, and " bold pwd normal " for the password "
end
return 1



/* ----------------------------------------------------------------------- */
/* HOST -- return the result of a HOST command  (a ping )                  */
/* ----------------------------------------------------------------------- */
/* This need not be in the main filter program                             */
/* It returns the GoServe command to send back the result                  */
  host: procedure
   parse arg eek
    do queued(); pull .; end                   /* flush */
    address cmd '@host' eek '| rxqueue'     /* execute the command */
    parse pull hostresult                      /* get result */
    return hostresult
/*
    crlf='0d0a'x
    return 'STRING host' arg(1)':'crlf crlf''hostresult
*/

/* -------------------- */
/* get a yes or no , return 1 if yes */
yesno0:procedure expose normal reverse bold
parse arg fooa , allopt
ayn='  '||bold||'Y'||normal||'es\'||bold||'N'||normal||'o'
do forever
 foo1=normal||reverse||fooa||normal||ayn
 call charout,  foo1 normal ':'
 pull anans
 if abbrev(anans,'Y')=1 then return 1
 if abbrev(anans,'N')=1 then return 0

end

/* -------------------- */
/* get a yes or no , return 1 if yes */
yesno:procedure expose normal reverse bold
parse arg fooa , allopt,altans
if altans<>" " & words(altans)>1 then do
   w1=strip(word(altans,1))
   w2=strip(word(altans,2))
   a1=left(w1,1) ; a2=left(w2,1)
   a1a=substr(w1,2) ; a2a=substr(w2,2)
end
else do
    a1='Y' ; a1a='es'
    a2='N' ; a2a='o'
end  /* Do */
ayn='  '||bold||a1||normal||a1a||'\'||bold||a2||normal||a2a

do forever
 foo1=normal||reverse||fooa||normal||ayn
 call charout,  foo1 normal ':'
 pull anans

 if abbrev(anans,a1)=1 then return 1
 if abbrev(anans,a2)=1 then return 0
end


/* ------------------------ */
/* ask for directory name,use defname2 as default */
/* give user opportunity to create it */

get_dir:procedure expose normal reverse bold re_wh
/* procedure expose reverse normal bold */
parse arg defname2 , mustsub
defname0=defname2

n2:
call charout ,  reverse ' <ENTER>=' defname2  normal ' ?'
pull godir

if godir=" " then godir=defname2
if godir="n.a." then signal n2


if mustsub<>"" then do    /* check 'must be subdirectory' option */
  if abbrev(godir,mustsub)=0 then do
     say " This directory MUST be under the " mustsub " directory! "
     say "  .. please re enter ! "
     signal n2
  end
end

godir=strip(godir,'t','\')
gdname=godir||"\*.*"


isme=directory()

isnew=directory(godir)
if isnew="" then do
   say "    Could not find  " godir
   if yesno(normal"        "re_wh"Would you like to create it")=1 then do
        oo=sysmkdir2(godir)
        if oo=0  then
           say "      Directory created: " godir
        else do
           say "      Could not create " godir "(error = " oo
           if godir=defname2 then defname2= "n.a."
           signal n2
        end
   end
   else do
        say " please reenter directory name ... "
        if godir=defname2 then defname2= "n.a."
        signal n2
   end
end  /* Do */


isme=directory(isme)



return godir

/* ------------- */
sysmkdir2:procedure
parse arg adir

adir=strip(adir,'t','\')
ff=sysmkdir(adir)
if ff=0 then return ff

/* make the tree */
f2=adir'\'
dd=filespec('d',f2)
pp=filespec('p',f2)
if pp='\' | pp='' then return -1

pp2=strip(translate(pp,' ','\'))

do mm=1 to words(pp2)
   a1=subword(pp2,1,mm)
   a1=translate(a1,'\',' ')
   dd2=dd'\'a1
   hoo=sysmkdir(dd2)
   if hoo=0 then say ' ... creating: 'dd2  
end /* do */

return hoo


/* ------------- */
/* ----------------------------------------------------------------------- */
/* REPLACESTRG: In string astring, find first occurence substring target and
.   replace it with substring putme
.      if no target, return unchanged astring
.      if no putme, then remove target
.      if type=backward, then find/change LAST occurence
.      if type=all, find/change all occurences
.      if exactmatch=yes, then do not capitalize during search (exact match only */
/* ----------------------------------------------------------------------- */

replacestrg: procedure

exactmatch=0
backward=0 ; doall=0

parse arg astring ,  target   , putme , type , exactmatch

type = translate(type)
if type="BACKWARD" then backward="YES"
if type="ALL" then doall="YES"

iat=1
joelen=length(target)
joelen2=length(putme)

doagain:                /* here if doall=yes */
 if exactmatch="YES" then do
    if   backward="YES" then
        joe= lastpos(target,astring)
    else
        joe= pos(target,astring,iat)
 end
 else do
   if   backward="YES" then
        joe= lastpos(translate(target),translate(astring))
    else
        joe= pos(translate(target),translate(astring),iat)
 end
 if joe=0 then
         return astring

 astring=delstr(astring,joe,joelen)
 if putme<>' ' then
    astring=insert(putme,astring,joe-1)

 if doall="YES" then do
     iat=joe+joelen2
     signal doagain
 end
/* else, all done */
 return astring

/* ----------------------------------------------------------------------- */
/* GRAB_FILE read in a file, but first check to see if openable, and if
.   openable, open and read it.
.    Returns with the file, or with 0 if file not obtainable.
.    Note that file is closed before returning
.   in,
.    usage:   afile_string=grab_file(the_file,seconds_to_try_for)
*/
/* ----------------------------------------------------------------------- */


grab_file: procedure

parse arg afile

ause=stream(afile,'c','open read')
if ause<>"READY:" then
  return 0

goo=charin(afile,1,chars(afile))
ause=stream(afile,'c','close')

/* get rid of ending ctl-z */
if c2d(right(goo,1))=26 then
  goo=left(goo,length(goo)-1)

return goo


/*******************************************/
/* check for existence of file, then ask user to copy or not */
/* note that for X.* type copies, it only checks once
   (not for each file, but just for any one of them */
/********************************************/
check_copy: procedure expose  reverse bold normal re_wh
parse arg file1, dest1 , amess , noask
dest2=strip(dest1,'t','\')||'\'

filename=dest1
if pos('.',dest1)=0 then filename=dest2||file1


aa=sysfiletree(filename,isit,'F')
ok=1
if aa<>0 then do
   say " Warning: error when looking for pre-existing copy of: " filename
   ok=yesno(" Do you want to copy this file (or files) anyways? ")
   if ok=1 & amess<>""  then
      ok=yesno(amess)
end

if noask=1 then signal doit3

if isit.0>0 then do
  if pos('*',file1)=0 then do
      say " "
      say " A file exists with the name: " filename
      ok=yesno(" Do you want to overwrite this file? ",1)
      if ok=1 & amess<>""  then ok=yesno(amess)
  end
  else do
    say " "
      say " There is at least one file that matches: " filename
      say "  (this match may " bold " not " normal " be one of the files that will be copied!) "
      ok=yesno(" Do you want to copy these files? ")
      if ok=1 & amess<>""  then ok=yesno(amess)
  end  /* Do */
end
if ok=0 then return 0

doit3:          /* jump here if noask=1 */
'COPY ' file1 dest1 ' > NUL '

return 1




 /* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1

   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd

   "@ANSI 2>NUL | rxqueue 2>NUL"

   thisRC = 0

   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */

 InitAnsiEnd:
 signal off error
 RETURN thisRC




/* get the hostname (aa.bb.cc) for this machine */
get_hostname: procedure expose re_wh
    do queued(); pull .; end                   /* flush */
    address cmd '@hostname | rxqueue'

    parse pull hostname
    return hostname



/******/
get_goserve_dir:

call lineout, bold  " What is GOSERVE's "working" directory? " normal
say "    *  The sreLite program files will be written there. "
say "    *  This does "bold"not"normal"  have to be the directory that contains GOSERVE.EXE"

n1:
godir=get_dir(defname)

if godir=" " then godir=defname
if godir="n.a." then signal n1

godir=strip(godir,'t','\')
gsname=godir||"\GOSERVE.EXE"

call sysfiletree gsname,gname2,'F'
if gname2.0=0 then do
   say " Note: GOSERVE.EXE is not currently installed in "godir
end  /* Do */

return 0

/**********/
get_www_dir:

say " "
call lineout, cy_ye" + + + + "normal BOLD " What is your data directory ?" normal
say  '    .. this is  the location of your "home page" document. '

datadir=get_dir(defname2)

return 0

/*********/
get_ip_address:
say "What is your IP address (it will be given OWNERS status)"
ipaddr=" "
thishost=get_hostname()
sagain:
call charout , BOLD "What is your IP address (ENTER="thishost "):? " normal
pull youraddr
if youraddr=' ' then youraddr=thishost

parse var youraddr t1 '.' .
isnum=0
if  datatype(t1)='NUM' then
  isnum=1
say " wait while that address is checked ... "
chk=host(youraddr)
if translate(word(chk,2))<>"IS" &  word(chk,2)<>"=" then do
    call lineout,re_wh " Unable to find  address: " youraddr normal
    say "    OWNER variable not assigned (but you can assign it later)"
    ipaddr=" "
end  /* Do */
else do
   if isnum then
     ipaddr=word(chk,1)
   else
     ipaddr=word(chk,3)

   say " Your IP address: " ipaddr
end
return 0

/***************/
init_it:

/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

nowdir=directory()

initfilt_file=''
echo off


/* --- Load the tcp/ip function library, if necessary --- */
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
  call RxFuncAdd "SockLoadFuncs","rxSock","SockLoadFuncs"
  call SockLoadFuncs
end

thishost=' '


parse version  atype .
if atype<>"REXXSAA" then do
 say    " WARNING: sreLite is designed to work under Classic Rexx "
 say     " In particular, it does NOT work under Object Rexx. "
 say     " Other versions of REXX, such as Quercus's REXX, have not been tested."
 say " Note: You are using REXX version: " atype
 say " (hit ENTER to continue) "
  pull .
end  /* Do */


/*---- load the rexxlib library */
droprxlib=0 ; gotrxlib=1
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 droprxlib=1 ; gotrxlib=0
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
    say " Could not find the REXXLIB procedure library (REXXLIB.DLL). "
    say "  Did you download it? "
    exit
end  /* Do */

if rxfuncquery('sref_fileread')<>0 then do
  ik=rxfuncadd('sref_fileread','rexxlib','LIB_FILEREAD')
  if ik<>0 then call pmprintff(' Warning: unable to register SREF_FILEREAD')
end

ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
cyanon=cy_ye
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  Install will look ugly ! "
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

/* some defaults */
    datadir="your GoServe Data-directory"
    workdir="your GoServe Working-directory"
   workdir_notset=1
    helpdir='the SAMPLES/ subdirectory of the GoServe Data-directory'
    useindex='  '


return 0


/*********/
check_macro:
if macroquery('SREF_VERSION')<>"" then do
     say " "
     say bold "A prior version of the sreLite (or SRE-http) macrospace procedures"normal
     say " were detected. We recommend clearing macrospace before you install sreLite."
     say " However, this might adversely impact other programs (that may also "
     say " use REXX's macrospace). "
     ok=yesno(" Clear macrospace now (Y) ?")
     if ok=1 then do
        say " .... clearing macrospace "
        foo=macroclear()
        say " "
     end  /* Do */
     else do
          say " "
        say  bold " Macrospace will not be cleared. " normal
        say " When you are ready to run GOSERVE with sreLite, we recommend "
        say " that you first reboot your server (otherwise sreLite will,"
        say " inappropriately, attempt to use the old procedure library)."
          say " "
     end  /* Do */
end  /* Do */
return 0


/************/
make_def_dirs:
    adir=filespec("drive",nowdir)
    defname=adir||'\GOSERVE'
    defname2=adir||'\WWW'
    call get_goserve_dir        /* but ask for a few directories */
    call get_www_dir

    gosds='TEMP DATA  CGI-BIN ADDON '
    wwwds='IMGS SAMPLES TEMP'

   say "The following sub directories will be created... "
   say  "    under "godir " : "bold|| gosds||normal
   say  "    under "datadir" :  "bold||wwwds||normal
   say " If this is not to your liking, you can stop this installation now."
   nn=yesno(normal'    Continue installing?')
   if nn=0 then do
       say "Installation discontinued. Please see SRELITE.DOC for installation instructions."
       exit
   end /* do */

    workdir=godir

    addon_dir=workdir'\addon'
    sdatadir=workdir||'\DATA'
    cgibin_dir=workdir||'\cgi-bin'
    tempdatadir=workdir'\temp'

    gifdir=datadir'\imgs'
    tempdir=datadir'\temp'
    helpdir=datadir'\samples'

    workdir_notset=0
    do ii=1 to words(gosds)
       a1=strip(word(gosds,ii))
       mdd=workdir'\'a1
       if dosisdir(mdd)=0 then do
          oo=sysmkdir(mdd)
          if oo<>0 then do 
            say 'ERROR: Could not create 'mdd ', error code= ' oo
            exit
         end /* do */
       end
    end /* do */
    do ii=1 to words(wwwds)
       a1=strip(word(wwwds,ii))
       mdd=datadir'\'a1
       if dosisdir(mdd)=0 then do
          oo=sysmkdir(mdd)
          if oo<>0 then do then
            say 'ERROR: Could not create 'mdd ', error code= ' oo
            exit
          end /* do */
       end
    end /* do */
return 1

