/*   */
optcfg:

CHECKIT=0   /* Set his to 1 if you want to DISBLE remote configuration by SUPERUSERS */
USECOLOR='2dd52f'

/* ---------------- DO NOT MODIFY BELOW THIS LINE  ------------------ */


parse arg ddir,tempfile,sel,list,verb,uri,user,basedir,workdir,privset,enmadd,transaction,verbose

if verb="" then do
   say " This sreLite add-on is NOT meant to be run from the command line."
   exit
end  /* Do */

signal on error name foo1 ; signal on syntax name foo1

crlf='0d0a'x
os2e='os2environment'
list=translate(list, ' ', '+'||'090a0d'x)  /* Whitespace, etc. */

who2=extract('CLIENTADDR')
saddr2=extract('SERVERADDR')

/****  Check for legitimacy of invocation */
select
   when checkit=1 then do
/* only if user = serveraddress !!! */
     if who2<>saddr2 | no_rem=2 then do

        call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
        call lineout tempfile, "<html><head><title>sreLite  remote configuartor disabled </title>"
        call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '

        call lineout tempfile,' <strong> Action not allowed remotely.</strong> <pre>'
        call lineout tempfile,' </body> </html> '
        call lineout tempfile
        ifoo=stream(tempfile,'c','query size')
        foo=sref_gos('FILE ERASE TYPE text/html NAME' tempfile)
        return '200 'ifoo
     end
   end
   otherwise do
      if wordpos('SUPERUSER',privset)=0 then do
        amess=' <strong> You do not have configuration rights.</strong> <p>'
        if who2=saddr2 then 
               amess=amess||'<br> <Em> You may need to enable remote configuation in OPTSCFGL.CMD </em> '
         rcode=sref_ask_auth('CONFIG_PARAMETERS',,servername,0,amess)
         return rcode
      end
   end
end

list=strip(list)
if pos('TODO=_MODIFY',pACKUR(list))>0 then signal modifyit

/*  ======= show form of values */

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
call lineout tempfile, "<html><head><title>sreLite: view and modify parameters </title>"
call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '
   
call lineout tempfile, "<h2> sreLite: view and modify user entries        </h2> <p>"
call lineout tempfile,'<FORM method="POST" action="/optsCFGL">'
call lineout tempfile,'<Input type="hidden" name="TODO" value="_MODIFY">'
call lineout tempfile,'<TABLE border=1><TR><th>Check to<br>modify</th><TH>Parameter</th><th>current value</th>'

/* get parameters from file */
call get_parameters

call lineout tempfile,'<tr>'
dolist=params.0
do forever
   if dolist='' then leave
   parse var dolist avar dolist
   avar=strip(avar)
   aa='!'avar
   aval=params.aa
   call lineout tempfile,'<tr><td><input type="checkbox" name="MODIFY" value="'avar'"></td>'
   call lineout tempfile,'<td><b>'avar'</b></td>'
   oo=make_cell(avar,aval)
   call lineout tempfile,'<td>'oo'</td>'

/* if xx.0 var, do for xx.1 .. to xx.(xx.0) */
  if pos('.0',avar)>0 then do
       parse var avar aa2 '.' . ; aa2=aa2'.'
       do kk=1 to params.aa
         avarx=aa2||kk;  baa='!'avarx ; avalx=params.baa
         call lineout tempfile,'<tr><td><input type="checkbox" name="MODIFY" value="'avarx'"></td>'
         call lineout tempfile,'<td><b>&nbsp;&nbsp;&nbsp;'avarx'</b></td>'
         oo=make_cell(avarx,avalx)
         call lineout tempfile,'<td>'oo'</td>'
       end /* do */
  end /* do */
end /* do */


call lineout tempfile,'</table> '

call lineout tempfile,'<input type="SUBMIT"><input type="RESET"></form>'
call lineout tempfile,'<hr><a href="/samples/srelite.doc" target="SRELITE_DOC">Show me the Manual.</a>'
call lineout tempfile,'</body></html>'
CALL LINEOUT TEMPFILE
foo=stream(tempfile,'c','query size')
'FILE ERASE TYPE text/html name 'tempfile
return '200 'foo



/*=====  MODIFY (2nd step), given response from a form  */
modifyit:
call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
call lineout tempfile, "<html><head><title>sreLite: modifying parameters </title>"
call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '
   
call lineout tempfile, "<h2> sreLite: modifying parameters        </h2> <p>"

/* get parameters from file */
call get_parameters

/* get parameters sent by the client. Note: only change those marked as MODIFY */
modlist=''
do until list=''
   parse var list a1 '&' list
   parse var  a1 avar '=' aval ;avar=strip(translate(avar))
   AVAL=PACKUR(TRANSLATE(AVAL,' ','+'||'0D0A'X))
   avarx='!'avar
   vals.avarx=aval
   if avar='MODIFY' then modlist=modlist' 'AVAL
end /* do */


/* Create a backup */
oo=filespec('d',inifile)||filespec('p',inifile)'SRELITE.???'
toydog=dostempname(oo)
foo=dosrename(inifile,toydog)
if foo=1 then do
  call lineout tempfile,'<p>Old <tt>'inifile'</tt> moved to <tt> 'toydog '</tt>'
end
else do
  call lineout tempfile,'<p>Error. Could not rename old <tt> 'inifile '</tt> to <tt>'toydog'</tt>'
  call lineout tempfile,'</body></html>'
  call lineout tempfile
  CALL LINEOUT TEMPFILE
  foo=stream(tempfile,'c','query size')
  'FILE ERASE TYPE text/html name 'tempfile
  return '200 'foo
end

/* modify values... */
do mm=1 to lins.0
  alin=strip(lins.mm)
  if alin='' | abbrev(alin,';')=1 then do
     call lineout inifile,alin
     iterate
  end /* do */
  parse var alin avar0 '=' aval0
  avar0=strip(translate(avar0))
  ido=wordpos(avar0,modlist)
  if ido=0 then do
     call lineout inifile,alin
     iterate
  end /* do */
  avarx='!'avar0
  call lineout inifile,avar0 ' = '||vals.avarx 
  modlist=delword(modlist,ido,1)
end /* do */

if modlist<>'' then do
   call lineout inifile,'; new additions on 'date('n')
   do forever
       if modlist='' then leave
       parse var modlist avar modlist
       avar0=strip(avar)
       avarx='!'avar0
       call lineout inifile,avar0 ' = '||vals.avarx 
   end /* do */
end /* do */
else

call lineout inifile

foo=value('SRELITE_RESET',1,'os2environment')
who=extract('clientaddr')
port=extract('serverport')
ff= SRELITE0.CMD(who,port,params.!verbose,params.!accept_range,1)

say " SET srelite_reset "
call lineout tempfile,'<p><b>'inifile' </b> succesfully created'
call lineout tempfile,'<p><a href="/OPTSCFGL?todo=SHOW">Redisplay parameters file </a>'
call lineout tempfile,'</body></html>'
CALL LINEOUT TEMPFILE
foo=stream(tempfile,'c','query size')
'FILE ERASE TYPE text/html name 'tempfile
return '200 'foo

/* modify entries */
do ii=1 to lins.0
   if  abbrev(strip(lins.ii),';')  then iterate
   if lins.ii=' ' then iterate
   ssl=strip(lins.ii)
   parse var ssl ss2 '=' . ; ss2=strip(translate(ss2))
   if wordpos(ss2,modlist)>0 then do
       ess2='!'ss2
       lins.ii= ss2' = ' params.ess2
   end /* do */
end 


dog=dostempname(oo)
foo=stream(inifile,'c','query exists')
if foo<>'' then do
  foo=dosrename(inifile,toydog)
  if  foo=1 then do
    call lineout tempfile,'<p>Old <tt>'inifile'</tt> moved to <tt> 'toydog '</tt>'
  end
  else do
    call lineout tempfile,'<p>Error. Could not rename old <tt> 'inifile '</tt> to <tt>'toydog'</tt>'
    call lineout tempfile,'</body></html>'
    call lineout tempfile
    CALL LINEOUT TEMPFILE
    foo=stream(tempfile,'c','query size')
    'FILE ERASE TYPE text/html name 'tempfile
    return '200 'foo
  end
end
do mm=1 to lins.0
   call lineout inifile,lins.mm
end /* do */
call lineout inifile
if foo=1  then
    call lineout tempfile,'<p><b>'inifile' </b> succesfully created.'

call lineout tempfile,'</body></html>'
CALL LINEOUT TEMPFILE
foo=stream(tempfile,'c','query size')
'FILE ERASE TYPE text/html name 'tempfile
return '200 'foo
***/

/***************/
/* load entries.!user .!pwd and .!privs */
get_parameters:
inifile=value('SRELI_INITFILE',,'os2environment')
inf=stream(inifile,'c','query size')
inhouseips.0=0 ; sel_requires.0=0 ; aliases.0=0
foo=stream(inifile,'c','open read')


stuff=charin(inifile,1,inf)
foo=stream(inifile,'c','close')
crlf='0d0a'x
params.=''
lins.0=0;ill=0
do forever
   if stuff='' then leave
   parse var stuff aline (crlf) stuff
   ill=ill+1
   lins.ill=aline
   lins.0=ill
   aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline  avar '=' aval
   avar=space(translate(avar),0)
   aval=strip(aval)
   if avar='' then iterate      /* bad value */
   if aval='' then aval="' '"
   a1=left(aval,1)
   if a1='"' | a1="'" then aval=strip(aval,,a1)
   aa='!'avar
   params.aa=aval

/* do NOT add .n (n>0) items to this list */
   parse var avar  a1 '.' a2 ; a2=strip(a2)
   if datatype(a2)='NUM' then do
       if a2>0 then iterate
   end
   params.0=params.0' 'avar

end

return 1


foo1:
say "optsCFGl error at " sigl ' ' rc
string "optsCFGl error at " sigl ' ' rc


exit



/*********************/
/* make an input cell */
make_cell:procedure
parse arg avarx,avalx
avarx=strip(translate(avarx))
select
   when avarX='ACCEPT_RANGE' then DO
      AA=make_radios(2,avalx,avarx,0,"Disable",1,"Enable")
   END

   when avarX='ADD_SLASH' then DO
      AA=make_radios(2,avalx,avarx,0,"Disable",1,"Enable")
   END


   WHEN AVARX='ALWAYS_GET_PRIVS' THEN DO
       AA=MAKE_RADIOS(3,AVALX,AVARX,0,'Check if necessary',1,'Always check',2,'Always check, ask if necessary')
   end

   when avarx='ALIASES.0' then do
        aa=' # of ALIASES= '||'<INPUT type="text" size=6 name="'avarx'" value='avalx'>'
        aa=aa||'<br>Alias.n  structure:<tt>/selector  /new_selector</tt>'
   end /* do */

   when avarx='INHOUSEIPS.0' then do
        aa=' # of INHouseIPs= '||'<INPUT type="text" size=6 name="'avarx'" value='avalx'>'
        aa=aa||'<br> InHouseIps.n structure:<tt> numeric_ip_address  privilege_list </tt>'
   end /* do */

    when avarx='SEL_REQUIRES.0' then do                                                                 
      aa=' # of SEL_requires= '||'<INPUT type="text" size=6 name="'avarx'" value='avalx'>'       
      aa=aa||'<br> Sel_requires.n structure:<tt>/a_selector  priv_list , use_this_file , no_log, realm </tt>'

   end /* do */                                                                                      
                                                                                                   
   when avarX='LOGIT' then DO
      AA=make_radios(2,avalx,avarx,0,"do NOT record to log file",1,"Record to log file")
   END


   when avarx='CHECK_SLASHS' then do
       aa=make_radios(2,avalx,avarx,0,'Disable',1,'Enable')
   end /* do */

   when avarx='DEFAULT_REQUIRES' then do
        aa='Default required privilege= '||'<input type="text" size=13 name="'avarx'" value="'avalx'">'
   end


   when avarx='DIR_EXCLUSION' then do
        aa='!DIR directory listing will not display these files and subdirectories:<br>'||'<input type="text" size=43 name="'avarx'" value="'avalx'">'
   end


   when avarx='NOT_FOUND_FILE' then do
        aa='A 404 response file (0=use generic response)= '||'<input type="text" size=13 name="'avarx'" value="'avalx'">'
   end

   when avarx='POST_FILTER' then do
        aa='Post Filter procedure (0=none) '||'<input type="text" size=13 name="'avarx'" value="'avalx'">'
   end

   when avarx='VERBOSE' then do
       aa=make_radios(3,avalx,avarx,0,'Errors Only',1,'CommonLog output',2,'Status Messages')
   end /* do */

   when avarx='SUPERUSERS' then do
        aa='List of numeric IP addresses granted SUPERUSER privileges (you can * as a wildcard)<br>: '||'<input type="text" size=43 name="'avarx'" value="'avalx'">'
   end

   when avarx="REALM" then do
        aa='Default Realm Name: '||'<input type="text" size=17 name="'avarx'" value="'avalx'">'

   end /* do */

   when avarx="HOME_DIR" then do
        aa='User-home directory (the ~ root): '||'<input type="text" size=17 name="'avarx'" value="'avalx'">'
   end /* do */

   when avarx='SSI_EXTENSIONS' then do
        aa='Server Side Include Extensions: '||'<input type="text" size=16 name="'avarx'" value="'avalx'">'
   end

   when avarx='DEFAULTS' then do
        aa='Default files to look for (!DIR means "display directory"): '||'<input type="text" size=40 name="'avarx'" value="'avalx'">'
   end


   otherwise do
       aa='<Input type="text" name="'avarx'" size=80 value="'avalx'">'
   end
end  /* select */
return aa






/********************************************/
/* --- create a row of radio buttons */
make_radioS:procedure
parse arg ndo,curval,thename
aa=''

do mm=1 to ndo
 MM2=MM*2
 thisval=arg(mm2+3-1)
 thisopt=arg(mm2+3)
 aa=aa||'<input type="radio" name="'thename'" '
 if curval=thisval then aa=aa||' CHECKED '
 aa=aa||'value="'thisval'" >'thisopt' '
 IF MM<NDO then AA=AA||' || '
end /* do */
RETURN AA
